<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { Ref, ref, watch } from 'vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { CarlConfigurationInterventionApi } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationInterventionApi'
    import { CarlConfigurationIntervention } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationIntervention'
    import { carlConfigurationInterventionMapper } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationInterventionMapper'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { useRoute, useRouter } from 'vue-router'
    import SCarlConfigurationInterventionForm from '@/shared/administration/components/interventionServiceOffer/gmaoConfigurationIntervention/SCarlConfigurationInterventionForm.vue'
    import SExpendableButton from '@/shared/button/components/SExpendableButton.vue'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const carlConfigurationIntervention: Ref<
        Partial<CarlConfigurationIntervention>
    > = ref({})

    const router = useRouter()
    const route = useRoute()
    const { getParentRoute } = useBreadcrumb()

    const msal = useMsal()
    const userStore = useUserStore(msal)

    const carlConfigurationInterventionId = route.params.id as string

    const carlConfigurationInterventionApi =
        new CarlConfigurationInterventionApi(msal)

    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isLoading.value = true
            carlConfigurationInterventionApi
                .get(carlConfigurationInterventionId)
                .then(async (fetchedCarlConfigurationIntervention) => {
                    carlConfigurationIntervention.value =
                        fetchedCarlConfigurationIntervention
                })
                .catch((error) => {
                    emitSnackBar((<Error>error).message, 'error')
                    router.push(getParentRoute())
                })
                .finally(() => (isLoading.value = false))
        },
        { immediate: true }
    )

    async function updateCarlConfigurationIntervention() {
        const carlConfigurationInterventionDto =
            carlConfigurationInterventionMapper.toEditDto(
                carlConfigurationIntervention.value
            )
        await carlConfigurationInterventionApi.update(
            carlConfigurationInterventionId,
            carlConfigurationInterventionDto
        )

        emitSnackBar(`Configuration Carl modifiée`, 'primary')
        router.push(getParentRoute())
    }

    const displayDeleteDialog = ref(false)

    function deleteCarlConfigurationIntervention() {
        displayDeleteDialog.value = true
    }

    function confirmDeleteCarlConfigurationIntervention() {
        carlConfigurationInterventionApi
            .delete(carlConfigurationInterventionId)
            .then(() => {
                displayDeleteDialog.value = false
                emitSnackBar(`Configuration Carl supprimée`, 'primary')
                router.push(getParentRoute())
            })
    }

    function cancelDeleteCarlConfigurationIntervention() {
        displayDeleteDialog.value = false
    }
</script>

<template>
    <s-contextual-navbar
        page-title="Modifier une configuration Carl d'intervention"
    >
        <template #contextualButtons>
            <s-expendable-button
                label="Dupliquer"
                icon="mdi-content-duplicate"
                data-cy="dupliquer-carl-configuration-intervention"
                @click="
                    router.push({
                        name: 'admin/configuration-carl-intervention/créer',
                        query: {
                            existingCarlConfigurationInterventionIdToDuplicate:
                                carlConfigurationInterventionId,
                        },
                    })
                "
            />
            <s-expendable-button
                label="Supprimer"
                icon="mdi-trash-can-outline"
                data-cy="supprimer-carlconfigurationintervention"
                @click="deleteCarlConfigurationIntervention()"
            />
        </template>
    </s-contextual-navbar>
    <v-main>
        <s-content-container>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading, actions"
            ></v-skeleton-loader>
            <s-carl-configuration-intervention-form
                v-else
                v-model="carlConfigurationIntervention"
                :loading="carlConfigurationInterventionApi.isProcessing.value"
                @submit.prevent="updateCarlConfigurationIntervention()"
            >
            </s-carl-configuration-intervention-form>
        </s-content-container>
    </v-main>
    <s-footer />

    <v-dialog v-model="displayDeleteDialog" max-width="600">
        <v-card title="Supprimer la configuration ?">
            <v-card-text>
                Cette configuration carl d'intervention sera définitivement
                supprimée
            </v-card-text>
            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                    color="on-background"
                    :disabled="
                        carlConfigurationInterventionApi.isProcessing.value
                    "
                    @click="cancelDeleteCarlConfigurationIntervention"
                    >Annuler</v-btn
                >
                <v-btn
                    color="error"
                    data-cy="confirm-delete-carlconfigurationintervention"
                    :loading="
                        carlConfigurationInterventionApi.isProcessing.value
                    "
                    @click="confirmDeleteCarlConfigurationIntervention"
                    >Supprimer</v-btn
                >
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>
